#include <stdio.h>
#include <lset.c>
#include <rnd/streqi.c>
#include <rnd/strconcat.c>
#include <rnd/sdreplace.c>
#include <rnd/fgetline.c>
#include <rnd/foreachfilein.c>
#include <rnd/foreachdirin.c>

void accumulatefile(const char *file,LSet *ps)
{
	if (!strcmpi(file+strlen(file)-2,".c"))
	{
		char *t; streqi(&t,file);
		LSet_add(ps,&t);
	}
}

void accumulatedir(const char *dir,LSet *ps)
{
	if (stristr(dir,"dailysrc\\")) return;
	printf("Scanning %s\n",dir);
	foreachfilein(dir,accumulatefile,ps);
	foreachdirin(dir,accumulatedir,ps);
}

void thestyle(FILE *out)
{
	fprintf(out,"<style>\n\
table {font-family:verdana,sans serif;font-size:8pt;border-collapse:collapse;margin:1em 0}\n\
td,th {border:1px solid #C0C0C0}\n\
</style>");
}

void srcsrch(const LSet files,const LSet strs,const char *outfile)
{
	int n,i,j; FILE *in; int **h=malloc(files.m*sizeof(int *));
	for (n=files.m-1;n>=0;n--) h[n]=calloc(strs.m,sizeof(int));
	LSet hits=LSet(char *); char **f=files.a,**s=strs.a,*l,hit,*fh=calloc(files.m,1);
	for (n=0;n<files.m;n++) if (in=fopen(f[n],"rb"))
	{
		printf("%s\n",f[n]);
		for (j=1;l=fgetline(in);j++)
		{
			hit=0;
			for (i=strs.m-1;i>=0;i--) if (stristr(l,s[i])) {h[n][i]++; hit=1;}
			if (hit)
			{
				char str[50],*r; streqi(&r,"<tr><td><a href='file://");
				strconcat(&r,f[n]);
				strconcat(&r,"'>");
				strconcat(&r,f[n]);
				strconcat(&r,"</a></td><td>");
				sprintf(str,"%d",j); strconcat(&r,str);
				strconcat(&r,"</td><td>");
				l=sdreplace(l,"<","&lt;"); strconcat(&r,l);
				strconcat(&r,"</td></tr>");
				LSet_add(&hits,&r); fh[n]=1;
			}
			free(l);
		}
		fclose(in);
	}
	FILE *out=fopen(outfile,"wt");
	fprintf(out,"<html><head>\n");
	thestyle(out);
	fprintf(out,"</head><body>\n<table>\n");
	for (n=-1;n<(int)files.m;n++) if (n<0 || fh[n])
	{
		fprintf(out,"<tr>");
		for (i=-1;i<(int)strs.m;i++)
			if (n>=0 && i>=0)
			{
				if (h[n][i]) fprintf(out,"<td>%d</td>",h[n][i]);
				else fprintf(out,"<td></td>");
			}
			else if (n>=0) fprintf(out,"<th><a href='file://%s'>%s</a></th>",f[n],f[n]);
			else if (i>=0) fprintf(out,"<th>%s</th>",s[i]);
			else fprintf(out,"<td></td>");
		fprintf(out,"</tr>\n");
	}
	fprintf(out,"</table>\n\n<table>");
	char **a=hits.a;
	for (n=0;n<hits.m;n++) fprintf(out,"%s\n",a[n]);
	fprintf(out,"</table>\n</body></html>");
	fclose(out);
	for (n=files.m-1;n>=0;n--) free(h[n]); free(h);
	for (n=hits.m-1;n>=0;n--) free(a[n]); LSet_free(hits);
	free(fh);
}

void add(LSet *ps,const char *s)
{
	char *t; streqi(&t,s); LSet_add(ps,&t);
}

#include <config.c>

int main(const int argc,const char *argv[])
{
	int n;
	LSet conf=configload("config.txt");
	char **roots=explode(",",configget(conf,"Search roots"));
	configfree(conf);
	LSet strs=LSet(char *);
	if (argc>1) for (n=1;n<argc;n++) add(&strs,argv[n]);
	else {char str[200]; printf("Search for what? "); scanf("%s",str); add(&strs,str);}
	LSet srcfiles=LSet(char *);
	for (n=explodesegs(roots)-1;n>=0;n--) accumulatedir(roots[n],&srcfiles);
	explodefree(roots);
	srcsrch(srcfiles,strs,"out.html");
	system("explorer out.html");
	return 0;
}
